Our Solutions

Need professional assistance?
Consider our:

Support Offerings


Need to speed up your development?
Have a look at our:

Samples & Tools


Need some functionality extending standard OCCT capabilities?
Check out our:

Adv. Components

offsetting a solid

hylkema's picture

Hello all, I'm trying to offset a solid in order to cut it with a cylinder (to simulate the regression in a star shaped solid propellant grain). The idea is to offset the kernel, cut it with the cylinder and then offset some more ...

for (int i = 1;i

Kernel = offset(0.1,Kernel);
Bloc = BRepAlgoAPI_Cut(Bloc,Kernel);

fileName WriteStep(fileName.str(),Bloc);

fileName WriteStep(fileName.str(),Kernel);

with offset as :

TopoDS_Shape Model2::offset(double dist,TopoDS_Shape original) {
double res = Precision::Confusion();
BRepOffset_MakeOffset mkOffset(original,dist,res);
TopoDS_Shape tmp = mkOffset.Shape();
return tmp;

This works for the first few itteration but that I have an instance of 'Standard_ConstructionError'

The kernel is defined in the attached file. All help is greatly appreciated